# Class: WMTS

## ol.source.WMTS

Layer source for tile data from WMTS servers.

#### new ol.source.WMTS(options) experimental

src/ol/source/wmtssource.js, line 37

  Name | Type | Description
  --- | --- | ---
  `options` | WMTS options.
  Name | Type | Description
  --- | --- | ---
  `attributions` | Array.<ol.Attribution> | undefined | optional Attributions.
  `crossOrigin` | string | null | undefined | optional crossOrigin setting for image requests.
  `extent` | ol.Extent | undefined | optional Extent.
  `logo` | string | undefined | optional Logo.
  `pixelRatio` | number | undefined | optional Device pixel ratio supported by the server.
  `tileGrid` | ol.tilegrid.WMTS | Tile grid.
  `projection` | ol.proj.ProjectionLike | Projection.
  `requestEncoding` | ol.source.WMTSRequestEncoding | undefined | optional Request encoding.
  `layer` | string | Layer.
  `style` | string | Style.
  `version` | string | undefined | optional WMTS version. Default to `1.0.0`.
  `format` | string | undefined | optional Format.
  `matrixSet` | string | Matrix set.
  `dimensions` | Object | undefined | optional Dimensions.
  `url` | string | undefined | optional URL.
  `maxZoom` | number | undefined | optional Maximum zoom.
  `tileLoadFunction` | ol.TileLoadFunctionType | undefined | optional Optional function to load a tile given a URL.
  `urls` | Array.<string> | undefined | optional Urls.

  ##### Fires:

  - `change` experimental - Triggered when the state of the source changes.

### Extends

- ol.source.TileImage

### Methods

#### staticol.source.WMTS.optionsFromCapabilities(wmtsCap, layer){olx.source.WMTSOptions} experimental

src/ol/source/wmtssource.js, line 248

  Name | Type | Description
  --- | --- | ---
  `wmtsCap` | Object | An object representing the capabilities document.
  `layer` | string | The layer identifier.

  ##### Returns:

  WMTS source options object.

#### dispatchChangeEvent() inherited experimental

src/ol/observable.js, line 41

  Dispatches a `change` event.

  ##### Fires:

  - `change` experimental

#### getDimensions(){Object} experimental

src/ol/source/wmtssource.js, line 204

  Get the dimensions, i.e. those passed to the constructor through the "dimensions" option, and possibly updated using the updateDimensions method.

  ##### Returns:

  Dimensions.

#### getState(){ol.source.State} inherited experimental

src/ol/source/source.js, line 142

  ##### Returns:

  State.

#### getTileGrid(){ol.tilegrid.TileGrid} inherited experimental

src/ol/source/tilesource.js, line 167

  ##### Returns:

  Tile grid.

#### getTileLoadFunction(){ol.TileLoadFunctionType} inherited experimental

src/ol/source/tileimagesource.js, line 130

  ##### Returns:

  TileLoadFunction

#### getTileUrlFunction(){ol.TileUrlFunctionType} inherited experimental

src/ol/source/tileimagesource.js, line 139

  ##### Returns:

  TileUrlFunction

#### on(type, listener, opt_this){goog.events.Key} inherited experimental

src/ol/observable.js, line 63

  Listen for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

  ##### Returns:

  Unique key for the listener.

#### once(type, listener, opt_this){goog.events.Key} inherited experimental

src/ol/observable.js, line 76

  Listen once for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

  ##### Returns:

  Unique key for the listener.

#### setTileLoadFunction(tileLoadFunction) inherited experimental

src/ol/source/tileimagesource.js, line 148

  Name | Type | Description
  --- | --- | ---
  `tileLoadFunction` | ol.TileLoadFunctionType | Tile load function.

#### setTileUrlFunction(tileUrlFunction) inherited experimental

src/ol/source/tileimagesource.js, line 159

  Name | Type | Description
  --- | --- | ---
  `tileUrlFunction` | ol.TileUrlFunctionType | Tile URL function.

#### un(type, listener, opt_this) inherited experimental

src/ol/observable.js, line 88

  Unlisten for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

#### unByKey(key) inherited experimental

src/ol/observable.js, line 98

  Removes an event listener using the key returned by `on()` or `once()`.

  Name | Type | Description
  --- | --- | ---
  `key` | goog.events.Key | Key.

#### updateDimensions(dimensions) experimental

src/ol/source/wmtssource.js, line 235

  Update the dimensions.

  Name | Type | Description
  --- | --- | ---
  `dimensions` | Object | Dimensions.